; SID Daemon b20131124 by insane
; 115200 baud 8N2
; fastdigi support:
; d418 is send as register select with bit 7=high
; (only when voice3 is NOT muted)

 *=$0801
	.byte $0C, $08      ; pointer to next line
	.word 2001          ; line number
	.byte $9E           ; SYS token
	.text " 2062"       ; SYS address in ASCII
	.byte 0, 0, 0       ; end-of-program

 start
	sei 

	lda #<start      ; set up restore key, so that it restarts the Daemon
	sta $318
	
	lda #>start
	sta $319
	
	lda $d011        ; turn off VIC-II
	and #$ef
	sta $d011
	
	lda #%01111111
	sta $dd0d	;no CIA#2 NMI interrupts
	lda $dd0d

	lda $dd02	
	ora #%00000100
	sta $dd02	;RS232 Data dir (bit 2=TxD)
	lda #%00000110
	sta $dd03	;RS232 Data dir (bit 0=RxD)

	lda $dd00	;set Txd HI
	and #%11111011
	ora #%00000100
	sta $dd00

	lda #%00001000
	sta $dd0e	;Timer off
	lda #%00001000
	sta $dd0f	;Timer off

	lda #0           
	ldx #$19
-
	dex
	sta $d400,x
	bne -

	sta $d020
	sta $d015	; no sprites

loop
;985248/115200=8.5525
;77cyc for S+0..7
;
;S01234567EE
;899899898  =8.5555
;
	lda #1   	;2	
-
	bit $dd01	;4
	bne -		;2
	nop      	;2=8

	ror $dd01,X	;7 b0
	ror A    	;2=9
	ror $dd01,X	;7 b1
	ror A    	;2=9
	ror $dd01,X	;7 b2
	ror A    	;2=9
	ror $dd01	;6 b3
	ror A    	;2=8
	ror $dd01,X	;7 b4
	ror A    	;2=9
	ror $dd01	;6 b5
	ror A    	;2=8
	ror $dd01,X	;7 b6
	ror A    	;2=9
	ror $dd01	;6 b7
	bcs dodigi	;2=80 | 3
	lsr A    	;2

	tay
	lda #1   	;2	
-
	bit $dd01	;4
	bne -		;2
	nop       	;2=8

	ror $dd01,X	;7 b0
	ror A    	;2=9
	ror $dd01,X	;7 b1
	ror A    	;2=9
	ror $dd01	;6 b2
	ror A    	;2=8
	ror $dd01,X	;7 b3
	ror A    	;2=9
	ror $dd01,X	;7 b4
	ror A    	;2=9
	ror $dd01	;6 b5
	ror A    	;2=8
	ror $dd01,X	;7 b6
	ror A    	;2=9
	ror $dd01	;6 b7
	ror A    	;2=8

smcmod
	sta $d400,y	;4
	jmp loop	;3

dodigi		 	;1
	lsr A		;2
	sta $d418 	;4
	jmp loop 	;3

