library HardSID;

uses windows;

const
{$IFDEF COM1}
  comport='\\.\COM1';
{$ENDIF}
{$IFDEF COM2}
  comport='\\.\COM2';
{$ENDIF}
{$IFDEF COM3}
  comport='\\.\COM3';
{$ENDIF}
{$IFDEF COM4}
  comport='\\.\COM4';
{$ENDIF}
{$IFDEF COM5}
  comport='\\.\COM5';
{$ENDIF}
{$IFDEF COM6}
  comport='\\.\COM6';
{$ENDIF}
{$IFDEF COM7}
  comport='\\.\COM7';
{$ENDIF}
{$IFDEF COM8}
  comport='\\.\COM8';
{$ENDIF}
{$IFDEF COM9}
  comport='\\.\COM9';
{$ENDIF}
{$IFDEF COM10}
  comport='\\.\COM10';
{$ENDIF}
{$IFDEF COM11}
  comport='\\.\COM11';
{$ENDIF}
{$IFDEF COM12}
  comport='\\.\COM12';
{$ENDIF}
{$IFDEF COM13}
  comport='\\.\COM13';
{$ENDIF}
{$IFDEF COM14}
  comport='\\.\COM14';
{$ENDIF}
{$IFDEF COM15}
  comport='\\.\COM15';
{$ENDIF}
{$IFDEF COM16}
  comport='\\.\COM16';
{$ENDIF}
  baudr='baud=115200 data=8 parity=N stop=2 dtr=on rts=on';

var
  sidregs:array[0..127] of byte;
  cport:handle;
  portset:dcb;
  n:longword;

procedure sendbyte(b:byte);
begin
  writefile(cport,b,1,n,nil);
end;

procedure InitHardSID_Mapper; stdcall; export;
begin
end;

function GetHardSIDCount: byte; stdcall; export;
begin
  GetHardSIDCount:=1;
end;

procedure MuteHardSID_Line(Mute: boolean); stdcall; export;
begin
end;

procedure WriteToHardSID(DeviceID, SID_reg, data: byte); stdcall; export;
begin
  if sid_reg<25 then
  begin
    if (data<>sidregs[sid_reg]) then
    begin
      sidregs[sid_reg]:=data;
      if ((sid_reg=$18) and ((data and 128)=0)) then
      begin
        sendbyte(data or $80);
      end else
      begin
        sendbyte(sid_reg and $7f);
        sendbyte(data);
      end;
    end;
  end;
end;

function ReadFromHardSID(DeviceID, SID_reg: byte): byte; stdcall; export;
begin
  ReadFromHardSID:=0;
end;

procedure SetDebug(Enabled: boolean); stdcall; export;
begin
end;

exports InitHardSID_Mapper,GetHardSIDCount,MuteHardSID_Line,
        WriteToHardSID,ReadFromHardSID,SetDebug;

var tmp:word;verid:string;
begin
  verid:='## Serial HARDSID Clone b20131125.1800 ##';
  for tmp:=0 to 23 do sidregs[tmp]:=0;sidregs[24]:=15;
  cport:=createfile(comport,GENERIC_READ or GENERIC_WRITE,0,nil,OPEN_EXISTING,0,0);
  fillchar(portset,sizeof(portset),0);
  portset.dcblength:=sizeof(portset);
  buildcommdcb(baudr,portset);
  setcommstate(cport,portset);

end.
